import $ from 'jquery';
import Element from 'ep-form/js/Element/Element';

/**
 * Unos količine.
 */
export default class Quantity extends Element
{
    /**
     * Konstruktor.
     *
     * @param el
     */
    constructor(el)
    {
        super(el);

        let $buttons = this.$el.find('button');

        this.minus = $buttons[0].ep;
        this.plus = $buttons[1].ep;
        this.input = this.$el.find('input')[0].ep;

        this.minus.$el
            .on('click', this.input.decrement.bind(this.input))
            .on('focus', this.onFocus.bind(this))
            .on('blur', this.onBlur.bind(this));

        this.plus.$el
            .on('click', this.input.increment.bind(this.input))
            .on('focus', this.onFocus.bind(this))
            .on('blur', this.onBlur.bind(this));

        this.input.$el
            .on('focus', this.onFocus.bind(this))
            .on('blur', this.onBlur.bind(this));

        $(this.input)
            .on('change', this.onChange.bind(this))
            .trigger('change');
    }

    /**
     * Da li je trenutna vrijednost ispravna.
     *
     * @returns {boolean}
     */
    get valid()
    {
        return this.input.valid;
    }

    /**
     * Trenutna vrijednost elementa.
     *
     * @returns {number}
     */
    get value()
    {
        return this.input.value;
    }

    /**
     * Kada kontrola izgubi fokus.
     */
    onBlur()
    {
        this.$el.removeClass('focus');
    }

    /**
     * Kada se promijeni vrijednost elementa.
     */
    onChange()
    {
        this.minus.enabled = this.input.value > this.input.min;
        this.plus.enabled = isNaN(this.input.max) || this.input.value < this.input.max;

        $(this).trigger('change');
    }

    onFocus()
    {
        this.$el.addClass('focus');
    }

    /**
     * Resetira element na početno stanje.
     */
    reset()
    {
        this.input.reset();
    }
}