<?php
namespace Ep\Woo\Form\View\Helper;

use Ep\Form\Helper\AbstractFormHelper;
use Ep\Woo\Form\Element\Quantity as QuantityElement;

/**
 * Renderira polje za odabir količine.
 *
 * @package Ep\Woo\Form\View\Helper
 * @author Elektronika Perhoč <support@ep.hr>
 * @link https://bitbucket.org/elektronika-perhoc/ep-woocommerce
 */
class Quantity extends AbstractFormHelper
{
    public function __invoke(QuantityElement $element)
    {
        if (!$element->getAttribute('id')) {
            $element->setAttribute('id', $this->generateId());
        }

        if (-1 === $element->getAttribute('max')) {
            $element->removeAttribute('max');
        }

        return $this->getView()->render('@woo/form/element/quantity.html.twig', [
            'element' => $element,
            'id' => $element->getAttribute('id'),
            'label' => $element->getLabel(),
        ]);
    }
}